---
title: Delete multiple key-value pairs
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[KV](https://developers.cloudflare.com/api/go/resources/kv)

[Namespaces](https://developers.cloudflare.com/api/go/resources/kv/subresources/namespaces)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Delete multiple key-value pairs

client.KV.Namespaces.BulkDelete(ctx, namespaceID, params) (\*[NamespaceBulkDeleteResponse](<https://developers.cloudflare.com/api/go/resources/kv#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkDeleteResponse%20%3E%20(schema)>), error)

POST/accounts/{account\_id}/storage/kv/namespaces/{namespace\_id}/bulk/delete

Deletes up to 10,000 key-value pairs from the specified Workers KV namespace. Send a JSON array of the key names to delete. The result reports the number of successful deletions and any keys that failed and should be retried.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Workers KV Storage Write`

##### ParametersExpand Collapse

namespaceID string

ID of the Workers KV namespace.

maxLength32

[Link to this property](<#(resource)%20kv.namespaces%20%3E%20(method)%20bulk_delete%20%3E%20(params)%20default%20%3E%20(param)%20namespace_id%20%3E%20(schema)>)

<details>

<summary>

params NamespaceBulkDeleteParams

</summary>

AccountID param.Field\[string]

Path param: ID of the Cloudflare account that owns the Workers KV namespaces.

maxLength32

<a href="#(resource)%20kv.namespaces%20%3E%20(method)%20bulk_delete%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

Body param.Field\[\[]string]

Body param

<a href="#(resource)%20kv.namespaces%20%3E%20(method)%20bulk_delete%20%3E%20(params)%20default%20%3E%20(param)%20body">Link to this property</a>

</details>

[Link to this property](<#(resource)%20kv.namespaces%20%3E%20(method)%20bulk_delete%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type NamespaceBulkDeleteResponse struct{…}

</summary>

SuccessfulKeyCount float64Optional

Number of keys successfully written or deleted by the bulk operation.

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkDeleteResponse%20%3E%20(schema)%20%3E%20(property)%20successful_key_count">Link to this property</a>

UnsuccessfulKeys \[]stringOptional

Names of keys that failed to be written or deleted. Retry the operation for these keys.

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkDeleteResponse%20%3E%20(schema)%20%3E%20(property)%20unsuccessful_keys">Link to this property</a>

</details>

[Link to this property](<#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkDeleteResponse%20%3E%20(schema)>)

### Delete multiple key-value pairs

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/kv"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  response, err := client.KV.Namespaces.BulkDelete(
    context.TODO(),
    "0f2ac74b498b48028cb68387c421e279",
    kv.NamespaceBulkDeleteParams{
      AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
      Body: []string{"My-Key"},
    },
  )
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", response.SuccessfulKeyCount)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "successful_key_count": 100,
    "unsuccessful_keys": [
      "string"
    ]
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "successful_key_count": 100,
    "unsuccessful_keys": [
      "string"
    ]
  }
}
```